#!/usr/local/bin/perl
#character code UTF-8.この行から10行はライセンスにより無許可では書き換えてはいけません。
#dat2txt.pl Ver 0.1 Copyright (C) 2010 大場正輝(Oba Masaki) All Rights Reserved.
# Mac OS Xの場合は、最初の行を #!/usr/bin/perl に書き換えないと動かない場合があります。
#Perl版 鍋田辞書CGIデータをperlを使ってコマンドラインでUTF-8テキストファイルに落とすツール
#ライセンス license
#使用は無料です。
#このスクリプトは許可なく再配布、公開は禁止です。
#改変は可能です。
#関連ソフト www.nabeta.tk 辞書ソフト 鍋田辞書 Windows/Linux/Free BSD/Perl CGI
#この行まで書き換えてはいけません。

#use CGI qw(:standard);
#データのファイル名を指定

$argc = @ARGV;
#$file1 = "nabeta.cgidat";
$file1 = $ARGV[0];
$file2 = $ARGV[1];

if($argc != 2){
  print STDERR "data2txt.pl NabetaJisho CGI data to Textfile converter.\n\n";
  print STDERR "USAGE: perl dat2txt.pl inputCGIdatafile outputTextfile\n";
  print STDERR "perl dat2txt.pl nabeta.cgidat nabeta.txt\n";
  exit 1;
}


#データ認識コード
#間違って他のデータを検索しないための鍋田辞書CGIデータという印
$data_version_code = 654018739;

sub hedda_yomikomi{
    #先頭にシーク
    #seek(DATA, 0, 0);
    #ファイル識別子読み込み
    $rl = read(DATA, $buf,4);
    if ($rl != 4) {
        print "Read ERROR Index file\n";
        close DATA; 
        exit 1;
    }
    $version_code = unpack("V",$buf);
    if($version_code != $data_version_code){
      print "EROR $file1 is not Nabeta CGI data file\n";
      close DATA; 
      exit 1;
    }

    #レコード数読み込み(データ数)(見出し数)
    $rl = read(DATA, $buf,4);
    if($rl != 4) {
        print "Read ERROR Index file\n";
        close DATA; 
        exit 1;
    }
    $rec_suu = unpack("V",$buf);
    if($rec_suu == 0){
      print "EROR Data size zero.$file1\n";
      close DATA; 
      exit 1;
    }

    #インデックス開始位置数読み込み
    $rl = read(DATA, $buf,4);
    if($rl != 4) {
        print "Read ERROR Index file\n";
        close DATA; 
        exit 1;
    }
    $index_kaishi_ichi = unpack("V",$buf);
    if($index_kaishi_ichi == 0){
      print "EROR Data size zero.$file1\n";
      close DATA; 
      exit 1;
    }

    #データ開始位置数読み込み
    $rl = read(DATA, $buf,4);
    if($rl != 4) {
        print "Read ERROR Index file\n";
        close DATA; 
        exit 1;
    }
    $data_kaishi_ichi = unpack("V",$buf);
    if($data_kaishi_ichi == 0){
      print "EROR Data size zero.$file1\n";
      close DATA; 
      exit 1;
    }
}

    open DATA, $file1 || die "Input Data file $file1 Open Error(read only)\n";
    open TXTOUT, ">$file2" || die "Output text file $file1 Open Error(read only)\n";
    binmode DATA;

    hedda_yomikomi();

    #データの著作権情報読み込み
    $yakugo = "";
    while (1){
      $c = getc(DATA);
      if($c eq "\0"){
        last;
      }
      $yakugo = $yakugo . $c; 
    }
    if($yakugo ne ""){
      #データの著作権情報出力
      print TXTOUT ";CopyrightNabeta\n";
      $yakugo =~ s/\r\n/\n/ig;
      print TXTOUT "$yakugo\n";
    }

    #全数ループ
    $k_cnt = 0;
    foreach($i=0;$i<$rec_suu;++$i){
      seek(DATA, $i * 4 + $index_kaishi_ichi, 0);
      $rl = read(DATA, $buf,4);
      if($rl != 4) {
          print "Read ERROR Index file\n";
          close DATA;
          close TXTOUT;
          exit 1;
      }
      $data_adr = unpack("V",$buf);

      seek(DATA, $data_adr + $data_kaishi_ichi,0);
      $tangos = "";
      while (1){
        $c = getc(DATA);
        if($c eq "\0"){
          last;   
        }       
        $tangos = $tangos . $c; 
      }

      if($tangos ne ""){
        $yakugo = "";
        while (1){
          $c = getc(DATA);
          if($c eq "\0"){
            last;
          }
          $yakugo = $yakugo . $c; 
        }
        print TXTOUT ";$tangos\n";
	$yakugo =~ s/\r\n/\n/ig;
        print TXTOUT "$yakugo\n";

        ++$k_cnt;
      }
    }
    if($k_cnt == 0){
      print STDERR "data zero\n";
    }
    else{
        print STDERR "Output $k_cnt data\n";
        print STDERR "to $file2\n";
    }
close DATA;
close TXTOUT;

